<template>
  <div class="qr">
    <div class="qr-container">
      <div class="qr-image">
        <img :src="urlQR" alt="Heta Authenticator QR code" v-if="!!urlQR">
      </div>
      <div class="secret_otp">
        <p class="secret">{{ key_2fa }}</p>
        <p class="description">{{ $t('otp.qr.desc') }}</p>
      </div>
    </div>
    <div class="clearfix"></div>
    <div class="qr-footer">
      <div class="qr-footer-left">
        <button class="btn-step btn-prev-step" @click="$emit('previous')" type="button"><i class="fa fa-angle-left" aria-hidden="true"></i> {{ $t('otp.btnPrev') }}</button>
      </div>
      <div class="qr-footer-right">
         <span>{{ $t('otp.qr.footer') }}</span>
        <button @click="nextStep()" type="button" class="btn-step btn-next-step">{{ $t('otp.btnNext') }} <i class="fa fa-angle-right" aria-hidden="true"></i></button>
      </div>
    </div>
  </div>
</template>

<script>
import { mapMutations } from 'vuex';

import rf from '../../requests/RequestFactory';

export default {
  data() {
    return {
      urlQR : '',
      key_2fa: '',
    }
  },
  methods : {
    ...mapMutations([
      'update2FaSecret',
    ]),
    getQRCodeGoogleUrl() {
      rf.getRequest('UserRequest').getQRCodeGoogleUrl()
        .then(res => {
          this.urlQR = res.data.url;
          this.key_2fa = res.data.key;
          this.update2FaSecret(res.data.key);
        });
    },
    nextStep () {
      if (!this.key_2fa) {
        return;
      }
      this.$emit('next');
    },
  },
  created () {
    this.getQRCodeGoogleUrl();
  }
}
</script>
<style lang="scss" scoped>
  @import '../../../../sass/_variables.scss';

  *{
    font-family: $font-family-home;
  }
  .qr {
    .qr-container {
      .qr-image {
        width: 120px;
        height: 120px;
        float: left;
        border: solid 1px #e0e0e0;
        display: flex;
        justify-content: center;
        img {
          width: 90px;
          height: 90px;
          margin-top: 14px;
        }
      }
      .secret_otp {
        float: left;
        width: 350px;
        margin-left: 25px;
        .secret {
          font-size: 16px;
          font-weight: bold;
          font-style: normal;
          font-stretch: normal;
          line-height: 3.13;
          letter-spacing: normal;
          color: #1c1c1c;
          margin: 0;
        }
        .description {
          font-weight: normal;
          font-style: normal;
          font-stretch: normal;
          line-height: 1.43;
          letter-spacing: normal;
          color: #707070;
        }
      }
    }
    .qr-footer {
      width: 100%;
      position: absolute;
      right: 60px;
      bottom: 0;
      .qr-footer-left {
        width: 180px;
        float: left;
        margin-left: 120px;
      }
      .qr-footer-right {
        width: 400px;
        float: right;
        text-align: right;
        span {
          font-size: 14px;
          color: $thin_gray;
        }
      }
    }
  }
  .btn-step {
    outline: none;
  }
</style>
